var _excluded = ["Tree", "multiple", "Tooltip", "onCheck", "checkedKeysMap", "checkStrictly", "rootClassName"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import { Icon } from 'rlj-design';
import classnames from 'classnames';
import "./style/antdTree.less";

// 二次封装Tree，使其兼容多选与单选，并且增加点击title进行选中的功能
// 为什么单独拿出来？是感觉如果需要的话，这个AntdTree可以单独在项目中拿出来使用
var AntdTree = function AntdTree(_ref) {
  var Tree = _ref.Tree,
      _ref$multiple = _ref.multiple,
      multiple = _ref$multiple === void 0 ? false : _ref$multiple,
      Tooltip = _ref.Tooltip,
      onCheck = _ref.onCheck,
      checkedKeysMap = _ref.checkedKeysMap,
      checkStrictly = _ref.checkStrictly,
      rootClassName = _ref.rootClassName,
      restProps = _objectWithoutProperties(_ref, _excluded);

  // 统一处理点击时的操作，主要是为了区分单选和多选时的处理
  var comCheckedHandle = function comCheckedHandle(info) {
    var node = info.node,
        checkedNodes = info.checkedNodes;
    var key = node.key; // 判断当前节点是否被勾选

    var hasChecked = checkedKeysMap.get(key);
    var temp = new Map(checkedKeysMap); // 判断当前是否单选，及当前节点是否选择，单选情况下二次点击不取消当前选择

    if (!multiple) {
      if (hasChecked) return false;
      temp.clear();
      temp.set(key, node);
    } else {
      // 当前为多选时，判断是否已经选中，如果当前已经选中了，那么就取消选中，如果当前未选中，那么就将当前项添加至选中数组
      // 多选状态下同时需要判断点击父节点是否关联勾选其子节点，通过checkStrictly来判断是否关联
      if (checkStrictly) {
        if (!hasChecked) {
          temp.set(key, node);
        } else {
          temp.delete(key);
        }
      } else {
        // 这里到时候需要后端支持一下到时候把部门链的id传过来，来判断部门链上的父部门是否被勾选
        temp = new Map();
        checkedNodes.map(function (item) {
          temp.set(item.key, item);
          return item;
        }).map(function (obj) {
          if (temp.has(obj.parentOrgId)) {
            temp.delete(obj.key);
          }
        });
      }
    }

    return temp;
  };

  var onTreeCheck = function onTreeCheck(checkedKeysValue, info) {
    onCheck && onCheck(checkedKeysValue, info, comCheckedHandle(info));
  };

  return /*#__PURE__*/React.createElement(Tree, _extends({
    onCheck: onTreeCheck,
    selectable: false,
    rootClassName: classnames('antdTree', _defineProperty({}, 'antdTreeRadio', !multiple), rootClassName),
    showLine: true,
    switcherIcon: /*#__PURE__*/React.createElement(Icon, {
      type: "xialajiantouzhankai"
    }),
    checkStrictly: checkStrictly,
    titleRender: function titleRender(nodeData) {
      return /*#__PURE__*/React.createElement(Tooltip, {
        title: nodeData === null || nodeData === void 0 ? void 0 : nodeData.tip
      }, /*#__PURE__*/React.createElement("span", {
        key: nodeData.key,
        className: classnames(_defineProperty({}, 'antdTreeDisabled', nodeData.tip))
      }, nodeData === null || nodeData === void 0 ? void 0 : nodeData.title));
    }
  }, restProps));
};

export default AntdTree;