import React, { ReactNode } from 'react';
export interface AntdTreeProps {
    Tree: any;
    multiple?: boolean;
    onCheck?: (checkedKeysValue: React.Key[], info: any, checkedKeysMap?: Map<React.Key, TreeNodeProps> | boolean) => void;
    [key: string]: any;
}
export interface SearchParamsType {
    empIds?: React.Key[];
    effectDate?: string;
    searchKey?: string;
    orgIds?: React.Key[];
}
export interface TreeNodeProps {
    emp?: {
        empId: string;
        name: string;
        orgChain: string;
    };
    org?: {
        name: string;
        haveChildren: boolean;
        orgChain: string;
        orgId: string;
        parentOrgId: string;
        syncStatus: boolean;
    };
    empName?: string;
    orgName?: string;
    empId?: string;
    orgId?: string;
    nodeType: number;
    key?: string;
    title?: string;
    children?: TreeNodeProps[];
    orgChain?: string;
    invalid?: boolean;
    loseEffect?: boolean;
    tip?: string;
}
export interface PROPS {
    open: boolean;
    title?: string;
    type?: 'dept' | 'person';
    multiple?: boolean;
    selectDept: Function;
    searchDeptChain: Function;
    searchPersonChain: Function;
    onCancel: () => void;
    disableNode?: {
        [key: string]: string;
    };
    onOk: (param: {
        label: string;
        value: string;
    }[], keyList: (string | number)[], keyMap: Map<React.Key, TreeNodeProps>) => void;
    value?: {
        label: string;
        value: string;
    }[];
    treeProps?: AntdTreeProps;
    customDataHandle?: (item: TreeNodeProps) => {
        title: ReactNode;
        isLeaf: boolean;
        icon: ReactNode | (() => ReactNode);
        checkable: boolean;
        nodeType: number;
        [key: string]: any;
    } & TreeNodeProps;
    defaultParams?: {
        [key: string]: any;
    };
    searchPlaceholder?: string;
}
