function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useRef, useState, createContext, useEffect } from 'react';
import classnames from 'classnames';
import { Popover, Form } from 'rlj-design';
import FilterBtn from "./FilterBtn";
import FilterContent from "./FilterContent";
import FilterResult from "./FilterResult";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-filter");
export var FilterContext = /*#__PURE__*/createContext(null);

var Filter = function Filter(props) {
  var overlayClassName = props.overlayClassName,
      trigger = props.trigger,
      btnText = props.btnText,
      btnRender = props.btnRender,
      filterTitle = props.filterTitle,
      filterSecondTitle = props.filterSecondTitle,
      filterNode = props.filterNode,
      showSelectedTag = props.showSelectedTag,
      items = props.items,
      total = props.total,
      unit = props.unit,
      filterOk = props.filterOk;

  var _Form$useForm = Form.useForm(),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      form = _Form$useForm2[0];

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      fields = _useState2[0],
      setFields = _useState2[1];

  var filterRef = useRef(null);

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      open = _useState4[0],
      setOpen = _useState4[1];

  var _useState5 = useState(new Map([])),
      _useState6 = _slicedToArray(_useState5, 1),
      itemsMap = _useState6[0];

  useEffect(function () {
    items === null || items === void 0 ? void 0 : items.forEach(function (_ref) {
      var fieldId = _ref.fieldId,
          fieldName = _ref.fieldName,
          fieldType = _ref.fieldType,
          multiSelect = _ref.multiSelect,
          type = _ref.type;
      itemsMap.set(fieldId, {
        fieldId: fieldId,
        fieldName: fieldName,
        fieldType: fieldType,
        multiSelect: multiSelect,
        type: type
      });
    });
  }, [items]);
  return /*#__PURE__*/React.createElement(FilterContext.Provider, {
    value: {
      items: items,
      total: total,
      unit: unit,
      filterOk: filterOk,
      fields: fields,
      setFields: setFields,
      itemsMap: itemsMap
    }
  }, /*#__PURE__*/React.createElement(Form, {
    form: form,
    name: "filter-content",
    autoComplete: "off"
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls,
    ref: filterRef
  }, /*#__PURE__*/React.createElement(Popover, {
    content: /*#__PURE__*/React.createElement(FilterContent, {
      filterTitle: filterTitle,
      filterSecondTitle: filterSecondTitle
    }),
    placement: "bottomLeft",
    trigger: trigger,
    overlayClassName: classnames("".concat(prefixCls, "-popover"), overlayClassName),
    getPopupContainer: function getPopupContainer() {
      return filterRef.current;
    },
    open: open,
    onOpenChange: function onOpenChange(open) {
      return setOpen(open);
    }
  }, btnRender ? btnRender : /*#__PURE__*/React.createElement(FilterBtn, {
    open: open,
    setOpen: setOpen
  }, btnText)), filterNode && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-filterNode")
  }, filterNode)), showSelectedTag && /*#__PURE__*/React.createElement(FilterResult, null)));
};

Filter.defaultProps = {
  trigger: "click",
  btnText: "筛选",
  unit: '项',
  total: 0,
  showSelectedTag: true
};
export default Filter;