function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useEffect, useMemo, useContext } from 'react';
import { Icon, Form } from 'rlj-design';
import FilterValue from "./FilterValue";
import { PREFIX_CLS } from "../constants/dictionary";
import { FilterContext } from "./Filter";
import "./style/filterContent.less";
var prefixCls = "".concat(PREFIX_CLS, "-filter-content");

var FilterContent = function FilterContent(props) {
  var filterTitle = props.filterTitle,
      filterSecondTitle = props.filterSecondTitle;

  var _Form$useFormInstance = Form.useFormInstance(),
      setFieldsValue = _Form$useFormInstance.setFieldsValue,
      validateFields = _Form$useFormInstance.validateFields;

  var _ref = useContext(FilterContext) || {},
      items = _ref.items,
      fields = _ref.fields;

  useEffect(function () {
    // 默认添加一项
    setFieldsValue({
      fields: [undefined]
    });
  }, []); // 这里给选项打个标，让已经被选择的下拉选项不显示

  var restItems = useMemo(function () {
    return (items || []).map(function (item) {
      return _objectSpread(_objectSpread({}, item), {}, {
        showOption: !(fields !== null && fields !== void 0 && fields.map(function (_ref2) {
          var fieldId = _ref2.fieldId;
          return fieldId;
        }).includes(item.fieldId))
      });
    });
  }, [fields, items]);

  var addNewItem = function addNewItem(add) {
    validateFields().then(function () {
      add();
    }).catch(function (error) {
      console.log(error);
    });
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-title")
  }, filterTitle, /*#__PURE__*/React.createElement("span", null, filterSecondTitle)), /*#__PURE__*/React.createElement(Form.List, {
    name: "fields"
  }, function (fields, _ref3) {
    var add = _ref3.add,
        remove = _ref3.remove;
    return /*#__PURE__*/React.createElement(React.Fragment, null, fields.map(function (item) {
      return /*#__PURE__*/React.createElement(FilterValue, {
        key: item.key,
        item: item,
        restItems: restItems,
        remove: remove
      });
    }), /*#__PURE__*/React.createElement(Form.Item, null, /*#__PURE__*/React.createElement("a", {
      className: "".concat(prefixCls, "-add"),
      onClick: function onClick() {
        return addNewItem(add);
      }
    }, /*#__PURE__*/React.createElement(Icon, {
      type: "tianjia"
    }), "\u6DFB\u52A0\u7B5B\u9009\u6761\u4EF6")));
  }));
};

FilterContent.defaultProps = {
  filterTitle: "筛选",
  filterSecondTitle: "（添加多个筛选条件，可交叉选择）"
};
export default FilterContent;