function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import { useContext } from 'react';
import moment from 'moment';
import { Tag } from 'rlj-design';
import { FilterContext } from "./Filter";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/filterResult.less";
var prefixCls = "".concat(PREFIX_CLS, "-filter-result");

var FilterResult = function FilterResult() {
  var _fields$;

  var _ref = useContext(FilterContext) || {},
      fields = _ref.fields,
      total = _ref.total,
      unit = _ref.unit,
      itemsMap = _ref.itemsMap,
      filterOk = _ref.filterOk;

  var valueHandle = function valueHandle(fieldId, value) {
    var _ref2 = itemsMap.get(fieldId) || {
      fieldName: '-',
      fieldType: 'string'
    },
        fieldName = _ref2.fieldName,
        fieldType = _ref2.fieldType,
        multiSelect = _ref2.multiSelect;

    var showValue = value;

    switch (fieldType) {
      case 'number':
      case 'string':
        break;

      case 'date':
        if (value) {
          var _value = _slicedToArray(value, 2),
              startDate = _value[0],
              endDate = _value[1];

          showValue = "".concat(moment(startDate).format('YYYY-MM-DD'), "~").concat(moment(endDate).format('YYYY-MM-DD'));
        }

        break;

      case 'emp':
      case 'org':
      case 'selection':
        console.log(value);

        if (typeof value !== 'string') {
          var _value$map;

          showValue = multiSelect ? value === null || value === void 0 ? void 0 : (_value$map = value.map(function (_ref3) {
            var label = _ref3.label;
            return label;
          })) === null || _value$map === void 0 ? void 0 : _value$map.join('、') : value === null || value === void 0 ? void 0 : value.label;
        }

        break;

      case 'address':
        console.log(value);
        break;

      case 'object':
        console.log(value);
        break;

      default:
        break;
    }

    return [fieldName, showValue];
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, // 这里的判断是至少有一条值的时候再出条件项展示
  !!(fields !== null && fields !== void 0 && fields.length && (_fields$ = fields[0]) !== null && _fields$ !== void 0 && _fields$.value) && /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-info")
  }, "\u5171\u7B5B\u9009\u51FA", /*#__PURE__*/React.createElement("strong", null, total), unit), fields.map(function (_ref4) {
    var fieldId = _ref4.fieldId,
        express = _ref4.express,
        value = _ref4.value;

    var _valueHandle = valueHandle(fieldId, value),
        _valueHandle2 = _slicedToArray(_valueHandle, 2),
        fieldName = _valueHandle2[0],
        showValue = _valueHandle2[1];

    return showValue && /*#__PURE__*/React.createElement("span", {
      key: fieldId,
      className: "".concat(prefixCls, "-conditions")
    }, /*#__PURE__*/React.createElement(Tag, {
      height: 20,
      type: "filter",
      closable: true
    }, fieldName, "\uFF1A", express, showValue));
  })));
};

export default FilterResult;