var _excluded = ["selectedItem", "fun"],
    _excluded2 = ["key", "name"],
    _excluded3 = ["multiSelect", "selection"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useContext } from 'react';
import { Input, Form, Select, Icon, InputNumber, DatePicker, SelectCheckbox } from 'rlj-design';
import { PREFIX_CLS } from "../constants/dictionary";
import { FilterContext } from "./Filter";
import "./style/filterValue.less";
var prefixCls = "".concat(PREFIX_CLS, "-filter-value");
var Option = Select.Option;
var RangePicker = DatePicker.RangePicker; // 这里写一个BaseWrapper容器让输入框能够接收到Form.Item给的props属性

var BaseWrapperHOC = function BaseWrapperHOC(_ref) {
  var selectedItem = _ref.selectedItem,
      fun = _ref.fun,
      restProps = _objectWithoutProperties(_ref, _excluded);

  var selection = selectedItem.selection,
      multiSelect = selectedItem.multiSelect;
  return /*#__PURE__*/React.createElement("span", null, fun(_objectSpread(_objectSpread({}, restProps), {}, {
    selection: selection
  }, typeof multiSelect === 'boolean' ? {
    multiSelect: multiSelect
  } : {})));
}; // const STATUS = {
//   string: 'value',
//   date: 'range',
//   selection: 'selections',
//   org: 'selections',
//   emp: 'selections',
//   object: 'selections'
// }


var FilterValue = function FilterValue(_ref2) {
  var remove = _ref2.remove,
      item = _ref2.item,
      restItems = _ref2.restItems;

  var _Form$useFormInstance = Form.useFormInstance(),
      setFieldValue = _Form$useFormInstance.setFieldValue,
      getFieldsValue = _Form$useFormInstance.getFieldsValue,
      resetFields = _Form$useFormInstance.resetFields;

  var key = item.key,
      name = item.name,
      restField = _objectWithoutProperties(item, _excluded2);

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      currentSelected = _useState2[0],
      setCurrentSelected = _useState2[1];

  var _ref3 = useContext(FilterContext) || {},
      filterOk = _ref3.filterOk,
      _ref3$fields = _ref3.fields,
      fields = _ref3$fields === void 0 ? [] : _ref3$fields,
      setFields = _ref3.setFields;

  var onChange = function onChange(e, options) {
    var _getFieldsValue;

    var _options$item = options.item,
        item = _options$item === void 0 ? {} : _options$item;
    var selected = fields === null || fields === void 0 ? void 0 : fields.map(function (_ref4) {
      var fieldId = _ref4.fieldId;
      return fieldId;
    });

    var _ref5 = currentSelected || {},
        fieldId = _ref5.fieldId;

    var index = fieldId ? selected.indexOf(fieldId) : -1;

    if (index >= 0) {
      selected.splice(index, 1);
    }

    selected.push(e);
    setCurrentSelected(item);
    setFieldValue(['fields', name, 'value'], null);
    setFields((_getFieldsValue = getFieldsValue()) === null || _getFieldsValue === void 0 ? void 0 : _getFieldsValue.fields);
  };

  var inputComponent = {
    string: function string(props) {
      return /*#__PURE__*/React.createElement(Input, _extends({
        allowClear: true
      }, props, {
        placeholder: "\u8BF7\u8F93\u5165"
      }));
    },
    number: function number() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return /*#__PURE__*/React.createElement(InputNumber, _extends({
        style: {
          width: 206
        },
        maxLength: 16,
        controls: false
      }, props, {
        placeholder: "\u8BF7\u8F93\u5165"
      }));
    },
    date: function date(props) {
      return /*#__PURE__*/React.createElement(RangePicker, _extends({
        style: {
          width: '100%'
        },
        allowClear: false
      }, props, {
        placeholder: ['开始日期', '结束日期']
      }));
    },
    selection: function selection(_ref6) {
      var multiSelect = _ref6.multiSelect,
          _selection = _ref6.selection,
          restProps = _objectWithoutProperties(_ref6, _excluded3);

      return multiSelect ? /*#__PURE__*/React.createElement(SelectCheckbox, _extends({
        options: _selection,
        showSelectAll: false
      }, restProps, {
        placeholder: "\u8BF7\u9009\u62E9"
      })) : /*#__PURE__*/React.createElement(Select, _extends({}, restProps, {
        placeholder: "\u8BF7\u9009\u62E9",
        labelInValue: true
      }), _selection && (_selection === null || _selection === void 0 ? void 0 : _selection.map(function (_ref7) {
        var label = _ref7.label,
            value = _ref7.value;
        return /*#__PURE__*/React.createElement(Select.Option, {
          key: value,
          value: value
        }, label);
      })));
    }
  };

  var onBlur = function onBlur() {
    var _getFieldsValue2;

    setFields((_getFieldsValue2 = getFieldsValue()) === null || _getFieldsValue2 === void 0 ? void 0 : _getFieldsValue2.fields);
    filterOk && filterOk(getFieldsValue());
  };

  var deleteItem = function deleteItem() {
    var _getFieldsValue3;

    // 判断当前只剩下一条的时候，只清空输入框内数据
    if (!key) {
      resetFields([['fields', name, 'fieldId'], ['fields', name, 'value']]);
      onBlur();
      return;
    }

    console.log(name);
    remove(name);
    setFields((_getFieldsValue3 = getFieldsValue()) === null || _getFieldsValue3 === void 0 ? void 0 : _getFieldsValue3.fields);
  };

  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-item")
  }, /*#__PURE__*/React.createElement(Form.Item, _extends({}, restField, {
    name: [name, 'fieldId'],
    style: {
      width: 160,
      marginRight: 8
    },
    rules: [{
      required: true,
      message: '不能为空'
    }]
  }), /*#__PURE__*/React.createElement(Select, {
    onChange: onChange,
    placeholder: "\u8BF7\u9009\u62E9\u5B57\u6BB5",
    allowClear: false,
    optionFilterProp: "children",
    showSearch: true,
    filterOption: function filterOption(input, option) {
      var _children, _children$toLowerCase;

      return (_children = option.children) === null || _children === void 0 ? void 0 : (_children$toLowerCase = _children.toLowerCase()) === null || _children$toLowerCase === void 0 ? void 0 : _children$toLowerCase.includes(input.toLowerCase());
    }
  }, restItems.map(function (item) {
    return (item.showOption || item.fieldId === (currentSelected === null || currentSelected === void 0 ? void 0 : currentSelected.fieldId)) && /*#__PURE__*/React.createElement(Select.Option, {
      key: item.fieldId,
      value: item.fieldId,
      item: item
    }, item.fieldName);
  }))), (currentSelected === null || currentSelected === void 0 ? void 0 : currentSelected.fieldType) === 'number' && /*#__PURE__*/React.createElement(Form.Item, _extends({}, restField, {
    name: [name, 'express'],
    style: {
      width: 86,
      marginRight: 8
    },
    rules: [{
      required: true,
      message: '不能为空'
    }]
  }), /*#__PURE__*/React.createElement(Select, {
    style: {
      width: 86,
      marginRight: 8
    },
    placeholder: "\u8BF7\u9009\u62E9"
  }, /*#__PURE__*/React.createElement(Option, {
    value: "="
  }, "="), /*#__PURE__*/React.createElement(Option, {
    value: ">"
  }, ">"), /*#__PURE__*/React.createElement(Option, {
    value: "\u2265"
  }, "\u2265"), /*#__PURE__*/React.createElement(Option, {
    value: "<"
  }, "<"), /*#__PURE__*/React.createElement(Option, {
    value: "\u2264"
  }, "\u2264"), /*#__PURE__*/React.createElement(Option, {
    value: "\u2260"
  }, "\u2260"))), /*#__PURE__*/React.createElement(Form.Item, _extends({}, restField, {
    name: [name, 'value'],
    style: {
      width: (currentSelected === null || currentSelected === void 0 ? void 0 : currentSelected.fieldType) === 'number' ? 206 : 300
    },
    rules: [{
      required: !!currentSelected,
      message: '不能为空'
    }],
    onBlur: onBlur,
    onKeyUp: function onKeyUp(e) {
      console.log(e.key);
    }
  }), !currentSelected ? /*#__PURE__*/React.createElement(Input, {
    style: {
      width: 300
    },
    disabled: true
  }) : inputComponent[currentSelected.fieldType] ? /*#__PURE__*/React.createElement(BaseWrapperHOC, {
    fun: inputComponent[currentSelected.fieldType],
    selectedItem: currentSelected
  }) : /*#__PURE__*/React.createElement(Input, null)), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-delete")
  }, /*#__PURE__*/React.createElement(Icon, {
    type: "shanchu",
    size: 16,
    onClick: deleteItem
  })));
};

export default FilterValue;