/// <reference types="react" />
import type { PopoverProps, TooltipProps } from 'rlj-design';
/**
 * @description 一个地方当需要hover展示信息的时候，需要根据不同的条件展示不同的信息
 * @param data [{key: 1, text: '没有权限', satisfy: true, childrenProps:{}}]
 * @param type 'popover' | 'tooltip'
 * @param children
 * @param fieldProps 对应PopoverProps和TooltipProps属性值
 * @date: 2022/11/25
 * @return
 * */
interface IData {
    text: string;
    satisfy: boolean;
    disabled?: boolean;
    childrenProps?: Object;
}
interface IProps {
    /** 传入数据*/
    data: Array<IData>;
    /** 展示的类型*/
    type?: 'popover' | 'tooltip';
    /** 传入的子节点*/
    children: any;
    /** 属性*/
    fieldProps?: PopoverProps | TooltipProps;
}
declare const PromptHoc: ({ type, data, children, fieldProps }: IProps) => JSX.Element;
export default PromptHoc;
