import { TableUnit, TableColumns } from '.';
import type { IdType, SortOrderType } from './base';
import type { DataContextType, ExcelContextType } from './redux';
export interface ColDataType {
    /** 宽度变化 */
    width: {
        [dataIndex in IdType]: number;
    };
    /** 排序 */
    sort: {
        key: IdType;
        value: SortOrderType;
        source: {
            [key in IdType]: any;
        } | undefined;
    };
    /** 表头折叠 */
    fold: {
        [dataIndex in IdType]: number;
    };
    /** 数据行折叠id，组织树场景 */
    expand: string[];
    /** 异步加载的组织树数据 */
    expandData: {
        [key in IdType]: any;
    };
    /** 编辑状态产生的单元格修改值 */
    changeDataSource: {
        [rowId in IdType]: {
            [dataIndex in IdType]: any;
        };
    };
    defaultItemHeight: number;
    defaultItemWidth: number;
    deleteDataRowIdArr: string[];
    addDataRowIdArr: string[];
    disableDate: {
        [rowId in IdType]: {
            [dataIndex in IdType]: any;
        };
    };
}
export declare type GridRefType = {
    scrollTo: (a: {
        scrollLeft: number;
        scrollTop: number;
    }) => void;
    resetAfterColumnIndex: (colIndex: number, flag: boolean) => void;
    resetAfterRowIndex: (colIndex: number, flag: boolean) => void;
    state: {
        scrollTop: number;
    };
} | null;
export declare type ColumnInfoType = {
    columnsWithHide: TableColumns<TableUnit>[];
    columns: TableColumns<TableUnit>[];
    lenAry: number[];
    lenRus: number;
    hierarchy: number;
    isShowCrossScrollBar: boolean;
    isShowDirScrollBar: boolean;
    scrollWidth: number;
    hierarchyHeight: number;
    height: number;
    boxHeight: number;
    contHeight: number;
    addBtnHeight: number;
    curMaxWidth: number;
    fixedLeft: {
        data: TableColumns<TableUnit>[];
        source: number[];
        res: number;
    };
    fixedRight: {
        data: TableColumns<TableUnit>[];
        source: number[];
        res: number;
    };
    noFixed: {
        data: TableColumns<TableUnit>[];
        source: number[];
        res: number;
    };
    dataSource: TableUnit[];
    dataSourceHeightInfo: number[];
    isEmptyData: boolean;
};
export interface TableCellType {
    isMergeRow?: boolean;
    rowIndex: number;
    subRowIndex: number;
    isMergeCol?: boolean;
    columnIndex: number;
    subColumnIndex: number;
    currentData: TableUnit;
    currentColumn: TableColumns<TableUnit>;
    excelCtx: ExcelContextType | null;
    dataCtx: DataContextType | null;
    mergeData?: Pick<TableUnit, 'mergeField' | 'mergeArr'>;
}
