function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { isValidElement, useRef, useState } from 'react';
import { Tooltip } from 'rlj-design';
import "./index.less";

var stopHoverFn = function stopHoverFn() {
  var extra = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  return window.tExcelResize || !extra;
}; // 拖动的时候要阻止hover，


export default function App(props) {
  var text = props.text,
      width = props.width,
      _props$hover = props.hover,
      hover = _props$hover === void 0 ? true : _props$hover,
      _props$isMaxWidth = props.isMaxWidth,
      isMaxWidth = _props$isMaxWidth === void 0 ? true : _props$isMaxWidth;
  var curSpanRef = useRef(null);
  var timerRef = useRef(null);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var onMouseEnter = function onMouseEnter() {
    if (stopHoverFn(hover)) return;

    var _ref = curSpanRef.current || {},
        offsetWidth = _ref.offsetWidth,
        scrollWidth = _ref.scrollWidth;

    if (!offsetWidth || !scrollWidth) return;

    if (offsetWidth < scrollWidth || width <= 22) {
      clearDelayTimer();
      toggleTooltip(true)();
    }
  };

  var onMouseLeave = function onMouseLeave() {
    if (stopHoverFn(hover)) return;
    window.inPopover = true;
    timerRef.current = window.setTimeout(function () {
      toggleTooltip(false)();
      clearDelayTimer();
    }, 100);
  };

  var clearDelayTimer = function clearDelayTimer() {
    if (timerRef.current) {
      clearTimeout(timerRef.current);
      timerRef.current = null;
    }
  };

  var toggleTooltip = function toggleTooltip(open) {
    return function () {
      setOpen(open);
    };
  };

  if ( /*#__PURE__*/isValidElement(text) || text === null || text === undefined) return /*#__PURE__*/React.createElement(React.Fragment, null, text);
  return /*#__PURE__*/React.createElement(Tooltip, {
    open: open,
    overlayClassName: "table_ellipsis_span_tooltip",
    title: /*#__PURE__*/React.createElement("div", {
      className: "table_ellipsis_span_tooltip_inner",
      onMouseEnter: clearDelayTimer,
      onMouseLeave: toggleTooltip(false)
    }, text)
  }, /*#__PURE__*/React.createElement("div", {
    ref: curSpanRef,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave,
    className: "table_ellipsis_span",
    style: _objectSpread({
      lineHeight: 1.6
    }, isMaxWidth ? {
      maxWidth: width
    } : {
      width: width
    })
  }, width <= 22 ? '...' : text));
}